// Copyright (c) 2018 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <vector>
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
namespace generated
{
    class CPACSControlSurfaceAirfoil;

    // This class is used in:
    // CPACSControlSurfaceOuterShapeTrailingEdge

    // generated from /xsd:schema/xsd:complexType[174]
    /// @brief Optional definition of the exact airfoil shape of the
    /// control surface.
    /// 
    /// 
    /// 
    class CPACSControlSurfaceContours
    {
    public:
        TIGL_EXPORT CPACSControlSurfaceContours();
        TIGL_EXPORT virtual ~CPACSControlSurfaceContours();

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::vector<std::unique_ptr<CPACSControlSurfaceAirfoil>>& GetIntermediateAirfoils() const;
        TIGL_EXPORT virtual std::vector<std::unique_ptr<CPACSControlSurfaceAirfoil>>& GetIntermediateAirfoils();

        TIGL_EXPORT virtual CPACSControlSurfaceAirfoil& AddIntermediateAirfoil();
        TIGL_EXPORT virtual void RemoveIntermediateAirfoil(CPACSControlSurfaceAirfoil& ref);

    protected:
        std::vector<std::unique_ptr<CPACSControlSurfaceAirfoil>> m_intermediateAirfoils;

    private:
        CPACSControlSurfaceContours(const CPACSControlSurfaceContours&) = delete;
        CPACSControlSurfaceContours& operator=(const CPACSControlSurfaceContours&) = delete;

        CPACSControlSurfaceContours(CPACSControlSurfaceContours&&) = delete;
        CPACSControlSurfaceContours& operator=(CPACSControlSurfaceContours&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSControlSurfaceContours = generated::CPACSControlSurfaceContours;
using CCPACSControlSurfaceAirfoil = generated::CPACSControlSurfaceAirfoil;
} // namespace tigl
