// Copyright (c) 2018 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <typeinfo>
#include <vector>
#include "CTiglError.h"
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
class CTiglUIDManager;
class CCPACSEnginePosition;

namespace generated
{
    // This class is used in:
    // CPACSAircraftModel
    // CPACSRotorcraftModel

    // generated from /xsd:schema/xsd:complexType[315]
    /// @brief enginePositionsType
    /// 
    /// EnginePositions type, containing a reference to the
    /// used engines and their positions at the configuration
    /// 
    class CPACSEnginePositions
    {
    public:
        TIGL_EXPORT CPACSEnginePositions(CTiglUIDManager* uidMgr);
        TIGL_EXPORT virtual ~CPACSEnginePositions();

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::vector<std::unique_ptr<CCPACSEnginePosition>>& GetEngines() const;
        TIGL_EXPORT virtual std::vector<std::unique_ptr<CCPACSEnginePosition>>& GetEngines();

        TIGL_EXPORT virtual CCPACSEnginePosition& AddEngine();
        TIGL_EXPORT virtual void RemoveEngine(CCPACSEnginePosition& ref);

    protected:
        CTiglUIDManager* m_uidMgr;

        std::vector<std::unique_ptr<CCPACSEnginePosition>> m_engines;

    private:
        CPACSEnginePositions(const CPACSEnginePositions&) = delete;
        CPACSEnginePositions& operator=(const CPACSEnginePositions&) = delete;

        CPACSEnginePositions(CPACSEnginePositions&&) = delete;
        CPACSEnginePositions& operator=(CPACSEnginePositions&&) = delete;
    };
} // namespace generated

// CPACSEnginePositions is customized, use type CCPACSEnginePositions directly
} // namespace tigl
