// Copyright (c) 2018 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <vector>
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
class CTiglUIDManager;

namespace generated
{
    class CPACSSeatModule;

    // This class is used in:
    // CPACSStructuralElements

    // generated from /xsd:schema/xsd:complexType[803]
    /// @brief seatModulesType
    /// 
    /// SeatModules type, containing seat modules
    /// 
    class CPACSSeatModules
    {
    public:
        TIGL_EXPORT CPACSSeatModules(CTiglUIDManager* uidMgr);
        TIGL_EXPORT virtual ~CPACSSeatModules();

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::vector<std::unique_ptr<CPACSSeatModule>>& GetSeatModules() const;
        TIGL_EXPORT virtual std::vector<std::unique_ptr<CPACSSeatModule>>& GetSeatModules();

        TIGL_EXPORT virtual CPACSSeatModule& AddSeatModule();
        TIGL_EXPORT virtual void RemoveSeatModule(CPACSSeatModule& ref);

    protected:
        CTiglUIDManager* m_uidMgr;

        std::vector<std::unique_ptr<CPACSSeatModule>> m_seatModules;

    private:
        CPACSSeatModules(const CPACSSeatModules&) = delete;
        CPACSSeatModules& operator=(const CPACSSeatModules&) = delete;

        CPACSSeatModules(CPACSSeatModules&&) = delete;
        CPACSSeatModules& operator=(CPACSSeatModules&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSSeatModules = generated::CPACSSeatModules;
using CCPACSSeatModule = generated::CPACSSeatModule;
} // namespace tigl
